﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WG_DisplayProgressIndicator
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraActivityIndicator1.AnimationEnabled = true;
            Task<DataTable> dataTask = Task.Factory.StartNew<DataTable>(() =>
                LoadDataSource() );

            Task completionTask = dataTask.ContinueWith((antecedent) =>
                {
                    ultraGrid1.DataSource = antecedent.Result;
                    ultraActivityIndicator1.AnimationEnabled = false;
                    ultraActivityIndicator1.Visible = false;
                }, 
                TaskScheduler.FromCurrentSynchronizationContext());
        }

        private DataTable LoadDataSource()
        {
            //simulate time consuming task
            DataTable dt = new DataTable();
            dt.Columns.Add("ID", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Column 1", typeof(string));
            dt.Columns.Add("Column 2", typeof(string));
            dt.Columns.Add("Column 3", typeof(string));
            dt.Columns.Add("Column 4", typeof(string));
            dt.Columns.Add("Column 5", typeof(string));

            for (int i = 0; i < 1000; i++)
            {
                dt.Rows.Add( new object[] { null, "Column 1, Row " + i, "Column 2, Row " + i,"Column 3, Row " + i,"Column 4, Row " + i,"Column 5, Row " + i});
                Thread.Sleep(10);

            }
            return dt;
        }
    }
}
